#include "mex.h"
#include <cmath>
#include <stdlib.h>
#include <stdio.h>
#include <queue>
#include "m_utils.h"
#include "m_malloc.h"
#include "m_Multi1DSegs.h"

using namespace std;

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]){
   /* check for the proper no. of input and outputs */
   if (nrhs != 2) mexErrMsgTxt("2 input arguments are required");
   if (nlhs>1) mexErrMsgTxt("Too many outputs");

   int PIXVALS_IN = 0;
   int GTLABEL_IN = 1;

   int len = mxGetM(prhs[PIXVALS_IN]);
   double *pixValsPtr = mxGetPr(prhs[PIXVALS_IN]);
   double *pixVals = (double *) mxCalloc(len, sizeof(double));
   double *gtLabelPtr = mxGetPr(prhs[GTLABEL_IN]);
   bool *gtLabel = (bool *) mxCalloc(len, sizeof(bool));
   for (int i=0; i < len; i++) {
      pixVals[i] = pixValsPtr[i];
      gtLabel[i] = gtLabelPtr[i];
   }

   int **nTPFPs =getTPFPsFor4allNSegs(pixVals, len, gtLabel);

   /* Create the outGoing Array  */
   plhs[0] = mxCreateDoubleMatrix(2, len, mxREAL);
   double *nTPFPsOutPtr = mxGetPr(plhs[0]);

   for (int k=0; k < len; k++){
      nTPFPsOutPtr[0] = nTPFPs[0][k];
      nTPFPsOutPtr[1] = nTPFPs[1][k];
      nTPFPsOutPtr += 2;
   }
   destroyMatrix<int>(nTPFPs, 2, len);
}
