#include <cmath>
#include <queue>
#include "m_malloc.h"
#include "m_utils.h"
#include "m_BranchBound.cpp"
#include "m_TreeNode1a.h"


void TreeNode1a::cmpBnds(){
   Window smallestWin = winPair.getSmallestWin();
   int *hist1_min = smallestWin.getHist(integralIms, nHistBin);
   Window largestWin = winPair.getLargestWin();
   int *hist1_max = largestWin.getHist(integralIms, nHistBin);
   lb = getLowerBnd1(hist1_min, hist1_max, hist_target, binWeights, nHistBin, C);
   ub = cmpEnergy(hist1_max, hist_target, binWeights, nHistBin, C);

   destroyVector<int>(hist1_min, nHistBin);
   destroyVector<int>(hist1_max, nHistBin);
};


int ***TreeNode1a::integralIms = NULL;
int *TreeNode1a::hist_target = NULL;
double *TreeNode1a::binWeights = NULL;
int TreeNode1a::nHistBin = 0;
double TreeNode1a::C = 0;




Window findBox1a(int **imAssign, int imH, int imW, int *hist_target, double *weights,
                 int nHistBin, double C, double tolFactor, double knownBest){
   int ***integralIms = cmpIntegralIms(imAssign, imH, imW, nHistBin);
   Window biggestWin(0,0, imW-1, imH-1);
   TreeNode1a rootNode(WindowPair(biggestWin, biggestWin));

   Window bestBB = findBox1a_helper(integralIms, rootNode, hist_target, weights, nHistBin,
      C, tolFactor, knownBest);
   destroyArrayThree<int>(integralIms, imH, imW, nHistBin);
   return bestBB;
}

Window findBox1a_helper(int ***integralIms, TreeNode1a rootNode,
                      int *hist_target, double *weights, int nHistBin,
                      double C, double tolFactor, double knownBest){

   TreeNode1a::integralIms = integralIms;
   TreeNode1a::hist_target = hist_target;
   TreeNode1a::binWeights = weights;
   TreeNode1a::nHistBin = nHistBin;
   TreeNode1a::C = C;

   TreeNode1a bestNode = m_branch_bound<TreeNode1a>(rootNode, tolFactor);
   return bestNode.winPair.getLargestWin();
}
