#include "m_malloc.h"
#include "m_utils.h"
#include "m_BranchBound.cpp"
#include "m_TreeNode1g.h"


void
TreeNode1g::cmpBnds(){
   Res xx, yy;

   if ((!findEnds(Res(winPair.win1.ul_x, winPair.win1.lr_x),
        Res(winPair.win2.ul_x, winPair.win2.lr_x),
        Res(szRange.wmin, szRange.wmax), &xx)) ||
      (!findEnds(Res(winPair.win1.ul_y, winPair.win1.lr_y),
        Res(winPair.win2.ul_y, winPair.win2.lr_y),
        Res(szRange.hmin, szRange.hmax), &yy))){

       lb = INF;
       ub = INF;
       return;
   }

   ubWin = Window(xx.x, yy.x, xx.y, yy.y);
   if ((ubWin.ul_x > ubWin.lr_x) ||
      (ubWin.ul_y > ubWin.lr_y)){
       ubWin = Window();
   }

   double *hist_ub = ubWin.getPosNegScore(integralIms);

   Window inter1 = ubWin.intersectWin(gtWin);
   double minArea = (double)inter1.getArea();
   Window union1 = ubWin.unionWin(gtWin);
   double maxArea = (double)union1.getArea();
   ub = hist_ub[0] - hist_ub[1];
   if (maxArea > 0) ub += minArea/maxArea;


   Window smallestWin = winPair.getSmallestWin();
   double *hist1_min = smallestWin.getPosNegScore(integralIms);
   Window largestWin = winPair.getLargestWin();
   double *hist1_max = largestWin.getPosNegScore(integralIms);

   Window inter2 = smallestWin.intersectWin(gtWin);
   double minArea2 = (double)inter2.getArea();
   Window union2 = largestWin.unionWin(gtWin);
   double maxArea2 = (double)union2.getArea();
   lb = hist1_min[0] - hist1_max[1];
   if (maxArea2 > 0) lb += minArea2/maxArea2;

   destroyVector<double>(hist1_min, 2);
   destroyVector<double>(hist1_max, 2);
   destroyVector<double>(hist_ub, 2);
}


double ***TreeNode1g::integralIms = NULL;
SizeRange TreeNode1g::szRange;
Window TreeNode1g::gtWin;



TreeNode1g findBox1g_helper(int & imW, int & imH, double ***& integralIms,
      SizeRange szRange, Window gtWin)
{
    Window biggestWin(0, 0, imW - 1, imH - 1);
    TreeNode1g rootNode(WindowPair(biggestWin, biggestWin));
    double tolFactor = 0;
    TreeNode1g::integralIms = integralIms;
    TreeNode1g::szRange = szRange;
    TreeNode1g::gtWin = gtWin;
    TreeNode1g bestNode = m_branch_bound<TreeNode1g>(rootNode, tolFactor);
    return bestNode;
}

Window findBox1g(int **kpAssign, int nKeyPnt, int imH, int imW,
                 double *weights, int nHistBin,
                 Window gtWin, SizeRange szRange){
   double ***integralIms =
      cmpIntegralIms3(kpAssign, nKeyPnt, imH, imW, weights, nHistBin);
   TreeNode1g bestNode = findBox1g_helper(imW, imH, integralIms, szRange, gtWin);

   destroyArrayThree<double>(integralIms, imH, imW, 2);
   return bestNode.ubWin;
}


Window findBox1g2(double **pixVals, int imH, int imW, Window gtWin, SizeRange szRange){
   double ***integralIms = cmpIntegralIms4(pixVals, imH, imW);
   TreeNode1g bestNode = findBox1g_helper(imW, imH, integralIms, szRange, gtWin);
   destroyArrayThree<double>(integralIms, imH, imW, 2);
   return bestNode.ubWin;
}
