#ifndef M_TREENODE1H_H
#define M_TREENODE1H_H
#include "m_TreeNode1e.h"

class TreeNode1h:public TreeNode1e{
public:
   static double ***integralIms;
   static double ***cntIms; // integral image for couting
   static SizeRange szRange;
   Window ubWin;

   TreeNode1h(WindowPair winPair_):TreeNode1e(winPair_){};
   TreeNode1h():TreeNode1e(){};   
   void cmpBnds();   

   
};

/**
 * Find the best box in an image that minimizes:
 *    sum_i {weights(i)*hist(i)}/sum_i{hist(i)}
 * This function can be used to find the largest enclosing box.
 * Inputs:
 *    imAssign: a 2 dim array for histogram bin assignments, entries should be
 *       positive integers.
 *    imH, imW: heigh and width of the image
 *    weights: a 1-dim array for weights for histogram bins
 *    nHistBin: # of histogram bins 
 *    szRange: range for the width and height of the box.
 * Output:
 *    A best rectangle that minimizes the desired energy
 */
Window findBox1h(int **kpAssign, int nKeyPnt, int imH, int imW, 
                 double *weights, int nHistBin, 
                 SizeRange szRange); 

#endif
