/*
 * m_TreeNode1j_tests.cpp
 *
 * Created on: Oct 12, 2009
 * Author: Minh Hoai Nguyen, Carnegie Mellon University
 * Email:  minhhoai@cmu.edu, minhhoai@gmail.com
 */

#include <iostream>
#include <cmath>
#include <queue>
#include <string>
#include <sstream>
#include <fstream>
#include "m_utils.h"
#include "m_malloc.h"
#include "m_TreeNode1j.h"
#include "m_BranchBound.cpp"
#include "m_tests.h"

void test1j_1(){
   int imH1 = 3;
   int imW1 = 4;

   int nTest = 12;
   int *nHistBin = buildVector<int>(nTest);
   int *nPC = buildVector<int>(nTest);
   double *alphas = buildVector<double>(nTest);



   int ***imAssign1 = buildArrayThree<int>(imH1, imW1, nTest);
   double ***B = buildVector<double**>(nTest);
   Window *expBBoxes = new Window[nTest];
   SizeRange *szRanges = new SizeRange[nTest];

   int i = 0;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(0,0,1,0);
   szRanges[i] = SizeRange(1, 3, 2, 4);
   nHistBin[i] = 2;
   nPC[i] = 2;
   B[i] = buildMatrix<double>(nPC[i], nHistBin[i]);
   B[i][0][0] = 1;
   B[i][0][1] = 0;
   B[i][1][0] = 0;
   B[i][1][1] = 0;


   i = 1;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(1,0,2,0);
   szRanges[i] = SizeRange(1, 3, 2, 4);
   nHistBin[i] = 2;
   nPC[i] = 2;
   B[i] = buildMatrix<double>(nPC[i], nHistBin[i]);
   B[i][0][0] = 0;
   B[i][0][1] = 0;
   B[i][1][0] = 0;
   B[i][1][1] = 1;


   i = 2;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(1,0,2,2);
   szRanges[i] = SizeRange(1, 3, 2, 4);
   nHistBin[i] = 2;
   nPC[i] = 2;
   B[i] = buildMatrix<double>(nPC[i], nHistBin[i]);
   B[i][0][0] = 1/sqrt(2);
   B[i][0][1] = 1/sqrt(2);
   B[i][1][0] = 1/sqrt(2);
   B[i][1][1] = -1/sqrt(2);

   i = 3;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 3;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 3; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(1,0,2,0);
   szRanges[i] = SizeRange(1, 3, 2, 4);
   nHistBin[i] = 3;
   nPC[i] = 2;
   B[i] = buildMatrix<double>(nPC[i], nHistBin[i]);
   B[i][0][0] = 1;
   B[i][0][1] = 0;
   B[i][0][2] = 0;
   B[i][1][0] = 0;
   B[i][1][1] = -1;
   B[i][1][2] = 0;

   i = 4;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 3; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 3;
   imAssign1[0][2][i] = 3; imAssign1[1][2][i] = 3; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(0,1,2,1);
   szRanges[i] = SizeRange(1, 3, 3, 4);
   nHistBin[i] = 3;
   nPC[i] = 2;
   B[i] = buildMatrix<double>(nPC[i], nHistBin[i]);
   B[i][0][0] = 1;
   B[i][0][1] = 0;
   B[i][0][2] = 0;
   B[i][1][0] = 0;
   B[i][1][1] = -1;
   B[i][1][2] = 0;

   i = 5;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 3; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 3;
   imAssign1[0][2][i] = 3; imAssign1[1][2][i] = 3; imAssign1[2][2][i] = 3;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(0,1,2,1);
   szRanges[i] = SizeRange(1, 3, 3, 4);
   nHistBin[i] = 3;
   nPC[i] = 2;
   B[i] = buildMatrix<double>(nPC[i], nHistBin[i]);
   B[i][0][0] = 1;
   B[i][0][1] = 0;
   B[i][0][2] = 0;
   B[i][1][0] = 0;
   B[i][1][1] = -1;
   B[i][1][2] = 0;

   i = 6;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 3; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 3;
   imAssign1[0][2][i] = 3; imAssign1[1][2][i] = 3; imAssign1[2][2][i] = 3;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;
   expBBoxes[i] = Window(0,1,2,1);
   szRanges[i] = SizeRange(1, 3, 3, 4);
   nHistBin[i] = 3;
   nPC[i] = 2;
   B[i] = buildMatrix<double>(nPC[i], nHistBin[i]);
   B[i][0][0] = 1/sqrt(2);
   B[i][0][1] = 1/sqrt(2);
   B[i][0][2] = 0;
   B[i][1][0] = 1/sqrt(2);
   B[i][1][1] = -1/sqrt(2);
   B[i][1][2] = 0;

   i = 7;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 3; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 3;
   imAssign1[0][2][i] = 3; imAssign1[1][2][i] = 3; imAssign1[2][2][i] = 3;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;
   expBBoxes[i] = Window(0,0,0,0);
   szRanges[i] = SizeRange(0, 0, 3, 4);
   nHistBin[i] = 3;
   nPC[i] = 2;
   B[i] = buildMatrix<double>(nPC[i], nHistBin[i]);
   B[i][0][0] = 1/sqrt(2);
   B[i][0][1] = 1/sqrt(2);
   B[i][0][2] = 0;
   B[i][1][0] = 1/sqrt(2);
   B[i][1][1] = -1/sqrt(2);
   B[i][1][2] = 0;

   i = 8;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 3; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 3;
   imAssign1[0][2][i] = 3; imAssign1[1][2][i] = 3; imAssign1[2][2][i] = 3;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;
   expBBoxes[i] = Window(0,1,2,1);
   szRanges[i] = SizeRange(1, 3, 3, 4);
   nHistBin[i] = 3;
   nPC[i] = 2;
   B[i] = buildMatrix<double>(nPC[i], nHistBin[i]);
   B[i][0][0] = 0;
   B[i][0][1] = 1/sqrt(2);
   B[i][0][2] = 1/sqrt(2);
   B[i][1][0] = 0;
   B[i][1][1] = -1/sqrt(2);
   B[i][1][2] = 1/sqrt(2);

   i = 9;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 3; imAssign1[1][1][i] = 1; imAssign1[2][1][i] = 3;
   imAssign1[0][2][i] = 3; imAssign1[1][2][i] = 3; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;
   expBBoxes[i] = Window(2,0,2,1);
   szRanges[i] = SizeRange(2, 3, 1, 4);
   nHistBin[i] = 3;
   nPC[i] = 2;
   B[i] = buildMatrix<double>(nPC[i], nHistBin[i]);
   B[i][0][0] = 0;
   B[i][0][1] = 1/sqrt(2);
   B[i][0][2] = 1/sqrt(2);
   B[i][1][0] = 0;
   B[i][1][1] = -1/sqrt(2);
   B[i][1][2] = 1/sqrt(2);

   i = 10;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 3; imAssign1[1][1][i] = 1; imAssign1[2][1][i] = 3;
   imAssign1[0][2][i] = 3; imAssign1[1][2][i] = 3; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;
   expBBoxes[i] = Window(1,0,2,1);
   szRanges[i] = SizeRange(2, 3, 2, 4);
   nHistBin[i] = 3;
   nPC[i] = 2;
   B[i] = buildMatrix<double>(nPC[i], nHistBin[i]);
   B[i][0][0] = 0;
   B[i][0][1] = 1/sqrt(2);
   B[i][0][2] = 1/sqrt(2);
   B[i][1][0] = 0;
   B[i][1][1] = -1/sqrt(2);
   B[i][1][2] = 1/sqrt(2);

   i = 11;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 3; imAssign1[1][2][i] = 3; imAssign1[2][2][i] = 3;
   imAssign1[0][3][i] = 2; imAssign1[1][3][i] = 3; imAssign1[2][3][i] = 3;
   expBBoxes[i] = Window(0,1,3,1);
   szRanges[i] = SizeRange(1, 3, 1, 4);
   nHistBin[i] = 3;
   nPC[i] = 1;
   B[i] = buildMatrix<double>(nPC[i], nHistBin[i]);
   B[i][0][0] = 1/sqrt(6);
   B[i][0][1] = 1/sqrt(6);
   B[i][0][2] = 2/sqrt(6);


   int **im1 = buildMatrix<int>(imH1, imW1);

   for (int k= 0; k < nTest; k++){
      cout << "==============Testing test1j_1." << k << endl;
      cout << "image 1: " << endl;
      for (int i = 0; i< imH1; i++){
         for (int j= 0; j < imW1; j++){
            im1[i][j] = imAssign1[i][j][k];
            printf("%2d ", im1[i][j]);
         }
         cout << endl;
      }


      int ***integralIms1 = cmpIntegralIms(im1, imH1, imW1, nHistBin[k]);
      int** kpAssign1 = imAssign2kpAssign(im1, imH1, imW1);


      //Test findBox1j1
      Window bestBBox = findBox1j1(kpAssign1, imH1*imW1, imH1, imW1, B[k], nHistBin[k], nPC[k], szRanges[k], alphas[k], 0.0);


      int *hist1_best = bestBBox.getHist(integralIms1, nHistBin[k]);
      double energy_best = cmpEnergy3(hist1_best, B[k], nHistBin[k], nPC[k], alphas[k]);

      cout << "Best window " << bestBBox.str()
           << ", energy: " << energy_best << endl;

      int *hist1_exp = expBBoxes[k].getHist(integralIms1, nHistBin[k]);
      double energy_exp = cmpEnergy3(hist1_exp, B[k], nHistBin[k], nPC[k], alphas[k]);

      if (energy_best < energy_exp - EPS){
         cout << "WARNING: expected energy is bigger than returned energy" << endl;
      } else if (energy_best > energy_exp + EPS){
         cout << "FAILED, expected BBoxes: " << expBBoxes[k].str() << ", energy " << energy_exp << endl;
      } else {
         cout << "PASSED" << endl;
      }

      destroyMatrix<int>(kpAssign1, imH1*imW1, 3);
      destroyArrayThree<int>(integralIms1, imH1, imW1, nHistBin[k]);
      destroyVector<int>(hist1_best, nHistBin[k]);
      destroyVector<int>(hist1_exp, nHistBin[k]);
      destroyMatrix<double>(B[k], nPC[k], nHistBin[k]);
      cout << endl;
   }

   destroyArrayThree<int>(imAssign1, imH1, imW1, nTest);
   destroyMatrix<int>(im1, imH1, imW1);
   delete [] expBBoxes;
   delete [] szRanges;
   destroyVector<int>(nHistBin, nTest);
   destroyVector<double>(alphas, nTest);
   destroyVector<int>(nPC, nTest);
   destroyVector<double**>(B, nTest);
}

void test1j_2(){
   int imH1 = 3;
   int imW1 = 4;

   int nTest = 13;
   int *nHistBin = buildVector<int>(nTest);
   int *nPC = buildVector<int>(nTest);
   double *alphas = buildVector<double>(nTest);


   int ***imAssign1 = buildArrayThree<int>(imH1, imW1, nTest);
   double ***B = buildVector<double**>(nTest);
   Window *expBBoxes = new Window[nTest];
   SizeRange *szRanges = new SizeRange[nTest];

   int i = 0;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;
   expBBoxes[i] = Window(0,0,1,0);
   szRanges[i] = SizeRange(1, 3, 2, 4);
   nHistBin[i] = 2;
   nPC[i] = 2;
   B[i] = buildMatrix<double>(nPC[i], nHistBin[i]);
   B[i][0][0] = 1;
   B[i][0][1] = 0;
   B[i][1][0] = 0;
   B[i][1][1] = 0;


   i = 1;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(1,0,2,0);
   szRanges[i] = SizeRange(1, 3, 2, 4);
   nHistBin[i] = 2;
   nPC[i] = 2;
   B[i] = buildMatrix<double>(nPC[i], nHistBin[i]);
   B[i][0][0] = 0;
   B[i][0][1] = 0;
   B[i][1][0] = 0;
   B[i][1][1] = 1;


   i = 2;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(1,0,2,2);
   szRanges[i] = SizeRange(1, 3, 2, 4);
   nHistBin[i] = 2;
   nPC[i] = 2;
   B[i] = buildMatrix<double>(nPC[i], nHistBin[i]);
   B[i][0][0] = 1/sqrt(2);
   B[i][0][1] = 1/sqrt(2);
   B[i][1][0] = 1/sqrt(2);
   B[i][1][1] = -1/sqrt(2);

   i = 3;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 3;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 3; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(1,0,2,0);
   szRanges[i] = SizeRange(1, 3, 2, 4);
   nHistBin[i] = 3;
   nPC[i] = 2;
   B[i] = buildMatrix<double>(nPC[i], nHistBin[i]);
   B[i][0][0] = 1;
   B[i][0][1] = 0;
   B[i][0][2] = 0;
   B[i][1][0] = 0;
   B[i][1][1] = -1;
   B[i][1][2] = 0;

   i = 4;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 3; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 3;
   imAssign1[0][2][i] = 3; imAssign1[1][2][i] = 3; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(0,1,3,1);
   szRanges[i] = SizeRange(1, 3, 3, 4);
   nHistBin[i] = 3;
   nPC[i] = 2;
   B[i] = buildMatrix<double>(nPC[i], nHistBin[i]);
   B[i][0][0] = 1;
   B[i][0][1] = 0;
   B[i][0][2] = 0;
   B[i][1][0] = 0;
   B[i][1][1] = -1;
   B[i][1][2] = 0;

   i = 5;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 3;
   imAssign1[0][2][i] = 3; imAssign1[1][2][i] = 3; imAssign1[2][2][i] = 3;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(0,1,3,1);
   szRanges[i] = SizeRange(1, 3, 3, 4);
   nHistBin[i] = 3;
   nPC[i] = 2;
   B[i] = buildMatrix<double>(nPC[i], nHistBin[i]);
   B[i][0][0] = 1;
   B[i][0][1] = 0;
   B[i][0][2] = 0;
   B[i][1][0] = 0;
   B[i][1][1] = -1;
   B[i][1][2] = 0;

   i = 6;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 3; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 3;
   imAssign1[0][2][i] = 3; imAssign1[1][2][i] = 3; imAssign1[2][2][i] = 3;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;
   expBBoxes[i] = Window(0,1,3,1);
   szRanges[i] = SizeRange(1, 3, 3, 4);
   nHistBin[i] = 3;
   nPC[i] = 2;
   B[i] = buildMatrix<double>(nPC[i], nHistBin[i]);
   B[i][0][0] = 1/sqrt(2);
   B[i][0][1] = 1/sqrt(2);
   B[i][0][2] = 0;
   B[i][1][0] = 1/sqrt(2);
   B[i][1][1] = -1/sqrt(2);
   B[i][1][2] = 0;

   i = 7;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 3; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 3;
   imAssign1[0][2][i] = 3; imAssign1[1][2][i] = 3; imAssign1[2][2][i] = 3;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;
   expBBoxes[i] = Window(0,0,0,0);
   szRanges[i] = SizeRange(1, 3, 1, 4);
   nHistBin[i] = 3;
   nPC[i] = 2;
   B[i] = buildMatrix<double>(nPC[i], nHistBin[i]);
   B[i][0][0] = 1/sqrt(2);
   B[i][0][1] = 1/sqrt(2);
   B[i][0][2] = 0;
   B[i][1][0] = 1/sqrt(2);
   B[i][1][1] = -1/sqrt(2);
   B[i][1][2] = 0;

   i = 8;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 3; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 3;
   imAssign1[0][2][i] = 3; imAssign1[1][2][i] = 3; imAssign1[2][2][i] = 3;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;
   expBBoxes[i] = Window(0,0,2,0);
   szRanges[i] = SizeRange(1, 3, 3, 4);
   nHistBin[i] = 3;
   nPC[i] = 2;
   B[i] = buildMatrix<double>(nPC[i], nHistBin[i]);
   B[i][0][0] = 0;
   B[i][0][1] = 1/sqrt(2);
   B[i][0][2] = 1/sqrt(2);
   B[i][1][0] = 0;
   B[i][1][1] = -1/sqrt(2);
   B[i][1][2] = 1/sqrt(2);

   i = 9;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 3; imAssign1[1][1][i] = 1; imAssign1[2][1][i] = 3;
   imAssign1[0][2][i] = 3; imAssign1[1][2][i] = 3; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;
   expBBoxes[i] = Window(2,0,2,1);
   szRanges[i] = SizeRange(2, 3, 1, 4);
   nHistBin[i] = 3;
   nPC[i] = 2;
   B[i] = buildMatrix<double>(nPC[i], nHistBin[i]);
   B[i][0][0] = 0;
   B[i][0][1] = 1/sqrt(2);
   B[i][0][2] = 1/sqrt(2);
   B[i][1][0] = 0;
   B[i][1][1] = -1/sqrt(2);
   B[i][1][2] = 1/sqrt(2);

   i = 10;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 3; imAssign1[1][1][i] = 1; imAssign1[2][1][i] = 3;
   imAssign1[0][2][i] = 3; imAssign1[1][2][i] = 3; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;
   expBBoxes[i] = Window(1,0,2,1);
   szRanges[i] = SizeRange(2, 3, 2, 4);
   nHistBin[i] = 3;
   nPC[i] = 2;
   B[i] = buildMatrix<double>(nPC[i], nHistBin[i]);
   B[i][0][0] = 0;
   B[i][0][1] = 1/sqrt(2);
   B[i][0][2] = 1/sqrt(2);
   B[i][1][0] = 0;
   B[i][1][1] = -1/sqrt(2);
   B[i][1][2] = 1/sqrt(2);

   i = 11;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 3; imAssign1[1][1][i] = 1; imAssign1[2][1][i] = 3;
   imAssign1[0][2][i] = 3; imAssign1[1][2][i] = 3; imAssign1[2][2][i] = 3;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;
   expBBoxes[i] = Window(1,0,2,2);
   szRanges[i] = SizeRange(2, 3, 2, 4);
   nHistBin[i] = 3;
   nPC[i] = 2;
   B[i] = buildMatrix<double>(nPC[i], nHistBin[i]);
   B[i][0][0] = 0;
   B[i][0][1] = 1/sqrt(2);
   B[i][0][2] = 1/sqrt(2);
   B[i][1][0] = 0;
   B[i][1][1] = -1/sqrt(2);
   B[i][1][2] = 1/sqrt(2);

   i = 12;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 3; imAssign1[1][1][i] = 1; imAssign1[2][1][i] = 3;
   imAssign1[0][2][i] = 3; imAssign1[1][2][i] = 3; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;
   expBBoxes[i] = Window(1,0,2,1);
   szRanges[i] = SizeRange(2, 2, 2, 4);
   nHistBin[i] = 3;
   nPC[i] = 2;
   B[i] = buildMatrix<double>(nPC[i], nHistBin[i]);
   B[i][0][0] = 0;
   B[i][0][1] = 1/sqrt(2);
   B[i][0][2] = 1/sqrt(2);
   B[i][1][0] = 0;
   B[i][1][1] = -1/sqrt(2);
   B[i][1][2] = 1/sqrt(2);



   int **im1 = buildMatrix<int>(imH1, imW1);

   for (int k= 0; k < nTest; k++){
      cout << "==============Testing test1j_2." << k << endl;
      cout << "image 1: " << endl;
      for (int i = 0; i< imH1; i++){
         for (int j= 0; j < imW1; j++){
            im1[i][j] = imAssign1[i][j][k];
            printf("%2d ", im1[i][j]);
         }
         cout << endl;
      }


      int ***integralIms1 = cmpIntegralIms(im1, imH1, imW1, nHistBin[k]);
      int** kpAssign1 = imAssign2kpAssign(im1, imH1, imW1);


      //Test findBox1j1
      Window bestBBox = findBox1j2(kpAssign1, imH1*imW1, imH1, imW1, B[k], nHistBin[k], nPC[k], szRanges[k], alphas[k], 0);


      int *hist1_best = bestBBox.getHist(integralIms1, nHistBin[k]);
      double energy_best = cmpEnergy4(hist1_best, B[k], nHistBin[k], nPC[k], alphas[k]);

      cout << "Best window " << bestBBox.str()
           << ", energy: " << energy_best << endl;

      int *hist1_exp = expBBoxes[k].getHist(integralIms1, nHistBin[k]);
      double energy_exp = cmpEnergy4(hist1_exp, B[k], nHistBin[k], nPC[k], alphas[k]);

      if (energy_best < energy_exp - EPS){
         cout << "WARNING: expected energy is bigger than returned energy" << endl;
      } else if (energy_best > energy_exp + EPS){
         cout << "FAILED, expected BBoxes: " << expBBoxes[k].str() << ", energy " << energy_exp << endl;
      } else {
         cout << "PASSED" << endl;
      }

      destroyMatrix<int>(kpAssign1, imH1*imW1, 3);
      destroyArrayThree<int>(integralIms1, imH1, imW1, nHistBin[k]);
      destroyVector<int>(hist1_best, nHistBin[k]);
      destroyVector<int>(hist1_exp, nHistBin[k]);
      destroyMatrix<double>(B[k], nPC[k], nHistBin[k]);
      cout << endl;
   }

   destroyArrayThree<int>(imAssign1, imH1, imW1, nTest);
   destroyMatrix<int>(im1, imH1, imW1);
   delete [] expBBoxes;
   delete [] szRanges;
   destroyVector<int>(nHistBin, nTest);
   destroyVector<double>(alphas, nTest);
   destroyVector<int>(nPC, nTest);
   destroyVector<double**>(B, nTest);
}


void test1j_3(){
   //char *fileName = "./data/test1j_3_data.txt";
   char *fileName = "./data/test1j_3_data2.txt";
   fstream myfile;
   myfile.open(fileName, fstream::in);
   if (myfile.fail()) cout << "fail to open file " << fileName << endl;


   double tmp;

   cout << "==========Testing test1j_3"<< endl;
   int imH, imW, nKeyPnt, nHistBin, nPC;
   myfile >> imH >> imW >> nKeyPnt >> nHistBin >> nPC;
   cout << "imH: " << imH << ", imW: " << imW << ", nKeyPnt: " << nKeyPnt <<
           ", nHistBin: " << nHistBin << ", nPC: " << nPC << endl;


   //reading matrix
   int **kpAssign = buildMatrix<int>(imH*imW, 3);
   for (int i= 0; i < nKeyPnt; i++){
      for (int j=0; j< 3; j++){
         myfile >> tmp;
         kpAssign[i][j] = (int) tmp;
         //printf("%2d ", kpAssign[i][j]);
      }
      //cout << endl;
   }


   //reading B
   cout << "PCA basis B" << endl;
   double **B = buildMatrix<double>(nPC, nHistBin);
   for (int i= 0; i < nHistBin; i++){
      for (int j=0; j < nPC; j++){
         myfile >> B[j][i];
         //cout << B[j][i] << " ";
      }
      //cout << endl;
   }

   double alpha = 0.0;
   SizeRange szRange(20, imH, 20, imW);
   Window bestBBox = findBox1j2(kpAssign, nKeyPnt, imH, imW, B, nHistBin, nPC, szRange, alpha, 0.1);

   int ***integralIms = cmpIntegralIms1(kpAssign, nKeyPnt, imH, imW, nHistBin);
   int *hist = bestBBox.getHist(integralIms, nHistBin);
   double energy = cmpEnergy4(hist, B, nHistBin, nPC, alpha);


   cout << "result : " <<  bestBBox.str() << ", Energy: " << energy << endl;

   destroyMatrix<int>(kpAssign, nKeyPnt, 3);
   destroyMatrix<double>(B, nPC, nHistBin);

   myfile.close();
};
