/*
 * m_TreeNode2c_tests.cpp
 *
 * Created on: Oct 25, 2009
 * Author: Minh Hoai Nguyen, Carnegie Mellon University
 * Email:  minhhoai@cmu.edu, minhhoai@gmail.com
 */

#include <iostream>
#include "m_tests.h"
#include "m_utils.h"
#include "m_malloc.h"
#include "m_TreeNode2c.h"

using namespace std;

void test2c_1(){
   int imH1 = 3;
   int imW1 = 4;
   int imH2 = 4;
   int imW2 = 3;

   int nTest = 7;
   int *nHistBin = buildVector<int>(nTest);
   double *alphas = buildVector<double>(nTest);


   int ***imAssign1 = buildArrayThree<int>(imH1, imW1, nTest);
   int ***imAssign2 = buildArrayThree<int>(imH2, imW2, nTest);

   WindowPair *expBBoxes = new WindowPair[nTest];
   SizeRange *szRange1s = new SizeRange[nTest];
   SizeRange *szRange2s = new SizeRange[nTest];

   int i = 0;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   imAssign2[0][0][i] = 1; imAssign2[1][0][i] = 1; imAssign2[2][0][i] = 1; imAssign2[3][0][i] = 1;
   imAssign2[0][1][i] = 1; imAssign2[1][1][i] = 2; imAssign2[2][1][i] = 2; imAssign2[3][1][i] = 1;
   imAssign2[0][2][i] = 1; imAssign2[1][2][i] = 1; imAssign2[2][2][i] = 1; imAssign2[3][2][i] = 1;

   nHistBin[i] = 2;
   alphas[i] = 2;
   expBBoxes[i] = WindowPair(Window(0,0,3,2), Window(0,1,1,2));
   szRange1s[i] = SizeRange(1, 3, 1, 4);
   szRange2s[i] = SizeRange(1, 4, 1, 3);

   i = 1;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   imAssign2[0][0][i] = 1; imAssign2[1][0][i] = 1; imAssign2[2][0][i] = 1; imAssign2[3][0][i] = 1;
   imAssign2[0][1][i] = 1; imAssign2[1][1][i] = 2; imAssign2[2][1][i] = 2; imAssign2[3][1][i] = 1;
   imAssign2[0][2][i] = 1; imAssign2[1][2][i] = 1; imAssign2[2][2][i] = 1; imAssign2[3][2][i] = 2;

   nHistBin[i] = 2;
   alphas[i] = 2;
   expBBoxes[i] = WindowPair(Window(0,0,3,2), Window(1,1,2,3));
   szRange1s[i] = SizeRange(1, 3, 1, 4);
   szRange2s[i] = SizeRange(1, 4, 1, 3);

   i = 2;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   imAssign2[0][0][i] = 1; imAssign2[1][0][i] = 1; imAssign2[2][0][i] = 1; imAssign2[3][0][i] = 2;
   imAssign2[0][1][i] = 1; imAssign2[1][1][i] = 2; imAssign2[2][1][i] = 2; imAssign2[3][1][i] = 1;
   imAssign2[0][2][i] = 1; imAssign2[1][2][i] = 1; imAssign2[2][2][i] = 1; imAssign2[3][2][i] = 2;

   nHistBin[i] = 2;
   alphas[i] = 2;
   expBBoxes[i] = WindowPair(Window(0,0,3,2), Window(0,1,2,3));
   szRange1s[i] = SizeRange(1, 3, 1, 4);
   szRange2s[i] = SizeRange(1, 4, 1, 3);

   i = 3;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   imAssign2[0][0][i] = 3; imAssign2[1][0][i] = 1; imAssign2[2][0][i] = 2; imAssign2[3][0][i] = 2;
   imAssign2[0][1][i] = 3; imAssign2[1][1][i] = 2; imAssign2[2][1][i] = 2; imAssign2[3][1][i] = 1;
   imAssign2[0][2][i] = 3; imAssign2[1][2][i] = 3; imAssign2[2][2][i] = 1; imAssign2[3][2][i] = 2;

   nHistBin[i] = 3;
   alphas[i] = 2;
   expBBoxes[i] = WindowPair(Window(0,0,2,2), Window(0,2,2,3));
   szRange1s[i] = SizeRange(1, 3, 1, 4);
   szRange2s[i] = SizeRange(1, 4, 1, 3);

   i = 4;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   imAssign2[0][0][i] = 3; imAssign2[1][0][i] = 4; imAssign2[2][0][i] = 4; imAssign2[3][0][i] = 4;
   imAssign2[0][1][i] = 3; imAssign2[1][1][i] = 4; imAssign2[2][1][i] = 4; imAssign2[3][1][i] = 3;
   imAssign2[0][2][i] = 3; imAssign2[1][2][i] = 3; imAssign2[2][2][i] = 3; imAssign2[3][2][i] = 4;

   nHistBin[i] = 4;
   alphas[i] = 2;
   expBBoxes[i] = WindowPair(Window(-1,-1,-1,-1), Window(-1,-1,-1,-1));
   szRange1s[i] = SizeRange(1, 3, 1, 4);
   szRange2s[i] = SizeRange(1, 4, 1, 3);

   i = 5;
   imAssign1[0][0][i] = 3; imAssign1[1][0][i] = 3; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   imAssign2[0][0][i] = 3; imAssign2[1][0][i] = 1; imAssign2[2][0][i] = 2; imAssign2[3][0][i] = 2;
   imAssign2[0][1][i] = 3; imAssign2[1][1][i] = 2; imAssign2[2][1][i] = 2; imAssign2[3][1][i] = 1;
   imAssign2[0][2][i] = 3; imAssign2[1][2][i] = 3; imAssign2[2][2][i] = 1; imAssign2[3][2][i] = 2;

   nHistBin[i] = 3;
   alphas[i] = 0.1;
   expBBoxes[i] = WindowPair(Window(0,0,3,1), Window(0,0,1,3));
   szRange1s[i] = SizeRange(1, 2, 1, 4);
   szRange2s[i] = SizeRange(1, 4, 1, 3);

   i = 6;
   imAssign1[0][0][i] = 3; imAssign1[1][0][i] = 3; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   imAssign2[0][0][i] = 3; imAssign2[1][0][i] = 1; imAssign2[2][0][i] = 2; imAssign2[3][0][i] = 2;
   imAssign2[0][1][i] = 3; imAssign2[1][1][i] = 2; imAssign2[2][1][i] = 2; imAssign2[3][1][i] = 1;
   imAssign2[0][2][i] = 3; imAssign2[1][2][i] = 3; imAssign2[2][2][i] = 1; imAssign2[3][2][i] = 2;

   nHistBin[i] = 3;
   alphas[i] = 0.1;
   expBBoxes[i] = WindowPair(Window(1,0,3,1), Window(0,2,2,3));
   szRange1s[i] = SizeRange(1, 2, 1, 4);
   szRange2s[i] = SizeRange(1, 2, 1, 3);

   int **im1 = buildMatrix<int>(imH1, imW1);
   int **im2 = buildMatrix<int>(imH2, imW2);

   for (int k= 0; k < nTest; k++){
      cout << "==============Testing test2c_1." << k << endl;
      cout << "image 1: " << endl;
      for (int i = 0; i< imH1; i++){
         for (int j= 0; j < imW1; j++){
            im1[i][j] = imAssign1[i][j][k];
            printf("%2d ", im1[i][j]);
         }
         cout << endl;
      }
      cout << "image 2: " << endl;
      for (int i = 0; i< imH2; i++){
         for (int j= 0; j < imW2; j++){
            im2[i][j] = imAssign2[i][j][k];
            printf("%2d ", im2[i][j]);
         }
         cout << endl;
      }

      int ***integralIms1 = cmpIntegralIms(im1, imH1, imW1, nHistBin[k]);
      int** kpAssign1 = imAssign2kpAssign(im1, imH1, imW1);
      int ***integralIms2 = cmpIntegralIms(im2, imH2, imW2, nHistBin[k]);
      int** kpAssign2 = imAssign2kpAssign(im2, imH2, imW2);


      //Test findBoxes2c
      WindowPair bestPair = findBoxes2c(kpAssign1, imH1*imW1, imH1, imW1, szRange1s[k],
            kpAssign2, imH2*imW2, imH2, imW2, szRange2s[k],
            nHistBin[i], alphas[i], 0.0);

      int *hist1_best = bestPair.win1.getHist(integralIms1, nHistBin[k]);
      int *hist2_best = bestPair.win2.getHist(integralIms2, nHistBin[k]);

      double energy_best = cmpEnergy5(hist1_best, hist2_best, nHistBin[k], alphas[k]);

      cout << "Best pair " << bestPair.str()
           << ", energy: " << energy_best << endl;


      int *hist1_exp = expBBoxes[k].win1.getHist(integralIms1, nHistBin[k]);
      int *hist2_exp = expBBoxes[k].win2.getHist(integralIms2, nHistBin[k]);

      double energy_exp = cmpEnergy5(hist1_exp, hist2_exp, nHistBin[k], alphas[k]);

      if (energy_best < energy_exp - EPS){
         cout << "WARNING: expected energy is bigger than returned energy" << endl;
      } else if (energy_best > energy_exp + EPS){
         cout << "FAILED, expected BBoxes: " << expBBoxes[k].str() << ", energy " << energy_exp << endl;
      } else {
         cout << "PASSED" << endl;
      }

      destroyMatrix<int>(kpAssign1, imH1*imW1, 3);
      destroyArrayThree<int>(integralIms1, imH1, imW1, nHistBin[k]);
      destroyVector<int>(hist1_best, nHistBin[k]);
      destroyVector<int>(hist1_exp, nHistBin[k]);

      destroyMatrix<int>(kpAssign2, imH2*imW2, 3);
      destroyArrayThree<int>(integralIms2, imH2, imW2, nHistBin[k]);
      destroyVector<int>(hist2_best, nHistBin[k]);
      destroyVector<int>(hist2_exp, nHistBin[k]);
      cout << endl;
   }

   destroyArrayThree<int>(imAssign1, imH1, imW1, nTest);
   destroyMatrix<int>(im1, imH1, imW1);
   destroyArrayThree<int>(imAssign2, imH2, imW2, nTest);
   destroyMatrix<int>(im2, imH2, imW2);

   delete [] expBBoxes;
   delete [] szRange1s;
   delete [] szRange2s;

   destroyVector<int>(nHistBin, nTest);
   destroyVector<double>(alphas, nTest);
}
